Package ru.bitel.bgbilling.kernel.contract.search.common.service

# Interface ContractSearchService

    public interface ContractSearchService

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `boolean` | `check​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation, java.lang.String searchData)` | Проверка подходил ли поисковой запрос под условия поиска
  `void` | `deleteSearch​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation)` |
  `ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation` | `getSearchById​(int id)` |
  `java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation>` | `getSearches()` |
  `java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation>` | `getSelectedSearches()` |
  `org.json.JSONObject` | `getTitles​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation)` | Список читабельных полей результата поиска.
  `java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation>` | `getValidadedSearches​(java.lang.String searchData)` |
  `java.util.List<org.json.JSONObject>` | `search​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation, java.lang.String searchData, int typeContract, boolean showSubContracts, boolean showClosed, boolean showHidden, javax.xml.ws.Holder<Page> pageHolder)` | Непосредственная реализация поиска
  `void` | `updateSearch​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation)` |
  `void` | `updateSearchList​(java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation> searchImplementationList)` |

- ## Method Details

  - ### getSearches

    java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation> getSearches() throws ru.bitel.bgbilling.common.BGException
    Returns:
      возвращает все классы-реализации поисков
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSelectedSearches

    java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation> getSelectedSearches() throws ru.bitel.bgbilling.common.BGException
    Returns:
      - возвращает все выбранные в настройке поиски
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getValidadedSearches

    java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation> getValidadedSearches​(java.lang.String searchData) throws ru.bitel.bgbilling.common.BGException
    Parameters:
      `searchData` - = поисковой запрос
    Returns:
      все реализации, которые проходят по условиям при вызове методов check()
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### check

    boolean check​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation, java.lang.String searchData) throws ru.bitel.bgbilling.common.BGException
    Проверка подходил ли поисковой запрос под условия поиска
    Parameters:
      `searchImplementation` - - реализация класса-поиска
      `searchData` - - поисковой запрос
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### search

    java.util.List<org.json.JSONObject> search​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation, java.lang.String searchData, int typeContract, boolean showSubContracts, boolean showClosed, boolean showHidden, javax.xml.ws.Holder<Page> pageHolder) throws ru.bitel.bgbilling.common.BGException
    Непосредственная реализация поиска
    Parameters:
      `searchImplementation` - - реализация поиска
      `searchData` - - поисковой запрос
      `typeContract` - - выбранный тип договоров. 0=физ.лицо, 1=юр.лицо, -1=любое
      `showSubContracts` - - показывать ли суб.договора
      `showClosed` - - показывать ли закрытые
      `showHidden` - - показывать ли скрытые
      `pageHolder` - - данные для построничного просмотра результатов
    Returns:
      произвольный список с результатами поиска, по которому будет строиться таблица
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getTitles

    org.json.JSONObject getTitles​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation) throws ru.bitel.bgbilling.common.BGException
    Список читабельных полей результата поиска. Ключи в JSON должны совпадать с ключами JSON возвращаемых методом search(). В качестве значений должны находиться JSON объекты с указанием названия полей и шириной(опционально)
    Parameters:
      `searchImplementation` - - реализация поиска
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSearchById

    ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation getSearchById​(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateSearch

    void updateSearch​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateSearchList

    void updateSearchList​(java.util.List<ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation> searchImplementationList)

  - ### deleteSearch

    void deleteSearch​(ru.bitel.bgbilling.kernel.contract.search.common.SearchImplementation searchImplementation) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`